//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "DrufelSMPPDemo"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
DrufelSMPPDemo1->Connect("192.1.1.1",2000);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DrufelSMPPDemo1Connect(TObject *Sender)
{
ListBox1->Items->Add("Connect. Press Bind.");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DrufelSMPPDemo1Bind_RESP_Error(TObject *Sender,
      TBindType Bind_Type, DWORD command_status, DWORD sequence_number,
      AnsiString system_id, TOPBind_RESP OPBind_RESP)
{
ListBox1->Items->Add("Bind_RESP_Error command_status:"+IntToStr(command_status));	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Bind_RESP_OK(TObject *Sender,
      TBindType Bind_Type, DWORD sequence_number, AnsiString system_id,
      TOPBind_RESP OPBind_RESP)
{
ListBox1->Items->Add("Bind_RESP_OK sc_interface_version:"+IntToHex(OPBind_RESP.sc_interface_version.Value,2));	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Cancel_RESP_Error(TObject *Sender,
      DWORD command_status, DWORD sequence_number)
{
ListBox2->Items->Add("Cancel_RESP_Error command_status:"+IntToStr(command_status)+" sequence_number:"+IntToStr(sequence_number));	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Cancel_RESP_OK(TObject *Sender,
      DWORD sequence_number)
{
ListBox2->Items->Add("Cancel_RESP_OK sequence_number:"+IntToStr(sequence_number));	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Connecting(TObject *Sender)
{
ListBox1->Items->Add("Connecting");	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Data_SM(TObject *Sender,
      DWORD sequence_number, AnsiString service_type, BYTE source_addr_ton,
      BYTE source_addr_npi, AnsiString source_addr, BYTE dest_addr_ton,
      BYTE dest_addr_npi, AnsiString destination_addr, BYTE esm_class,
      BYTE registered_delivery, BYTE data_coding, TOPData_SM &OPData_SM)
{
ListBox2->Items->Add("Data_SM:"+destination_addr);	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Data_SM_RESP_Error(TObject *Sender,
      DWORD command_status, DWORD sequence_number, AnsiString message_id,
      TOPData_SM_RESP &OPData_SM_RESP)
{
ListBox2->Items->Add("Data_SM_RESP_Error command_status:"+IntToStr(command_status));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Data_SM_RESP_OK(TObject *Sender,
      DWORD sequence_number, AnsiString message_id,
      TOPData_SM_RESP &OPData_SM_RESP)
{
ListBox2->Items->Add("Data_SM_RESP_OK message_id:"+message_id);	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Deliver_SM(TObject *Sender,
      DWORD sequence_number, AnsiString service_type, BYTE source_addr_ton,
      BYTE source_addr_npi, AnsiString source_addr, BYTE dest_addr_ton,
      BYTE dest_addr_npi, AnsiString destination_addr, BYTE esm_class,
      BYTE protocol_id, BYTE priority_flag, AnsiString schedule_delivery_time,
      AnsiString validity_period, BYTE registered_delivery,
      BYTE replace_if_present_flag, BYTE data_coding, BYTE sm_default_msg_id,
      BYTE sm_length, AnsiString short_message, TOPDeliver_SM &OPDeliver_SM)
{
DrufelSMPPDemo1->Deliver_SM_RESP(0,sequence_number,"");
//ListBox2->Items->Add("Submit_SM:"+IntToStr(DrufelSMPP1->Submit_SM("",0,1,"001",0,1,"001",0,0,0,"","",0,0,4,0," ",OPSubmit_SM)));
ListBox2->Items->Add("Deliver_SM_RESP From:"+source_addr+" to:"+destination_addr+" message:"+short_message);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Disconnect(TObject *Sender)
{
ListBox1->Items->Add("Disconnect");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Enquire_LINK(TObject *Sender,
      DWORD command_status, DWORD sequence_number)
{
DrufelSMPPDemo1->Enquire_LINK_RESP(sequence_number);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Enquire_LINK_RESP(TObject *Sender,
      DWORD command_status, DWORD sequence_number)
{
ListBox2->Items->Add("Enquire_LINK_RESP sequence_number:"+IntToStr(sequence_number));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Generic_NACK(TObject *Sender,
      DWORD command_status, DWORD sequence_number)
{
ListBox2->Items->Add("Generic_NACK command_status:"+IntToStr(command_status)+" sequence_number:"+IntToStr(sequence_number));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Query_SM_RESP_Error(TObject *Sender,
      DWORD command_status, DWORD sequence_number, AnsiString message_id,
      AnsiString final_date, BYTE message_state, BYTE error_code)
{
ListBox2->Items->Add("Query_SM_RESP_Error command_status:"+IntToStr(command_status));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Query_SM_RESP_OK(TObject *Sender,
      DWORD sequence_number, AnsiString message_id, AnsiString final_date,
      BYTE message_state, BYTE error_code)
{
ListBox2->Items->Add("Query_SM_RESP_OK sequence_number:"+IntToStr(sequence_number)+" message_id:"+message_id+
" final_date:"+final_date+" message_state:"+IntToStr(message_state)+"");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Replace_RESP_Error(TObject *Sender,
      DWORD command_status, DWORD sequence_number)
{
ListBox2->Items->Add("Replace_RESP_Error command_status:"+IntToStr(command_status)+" sequence_number:"+IntToStr(sequence_number));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Replace_RESP_OK(TObject *Sender,
      DWORD sequence_number)
{
ListBox2->Items->Add("Replace_RESP_OK sequence_number:"+IntToStr(sequence_number));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1SockError(TObject *Sender, int ErrorCode)
{
ListBox2->Items->Add("SockError:"+IntToStr(ErrorCode));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Submit_MULTI_RESP_Error(TObject *Sender,
      DWORD command_status, DWORD sequence_number, AnsiString message_id,
      BYTE no_unsuccess, Tunsuccess_sme unsuccess_sme)
{
ListBox2->Items->Add("Submit_MULTI_RESP_Error command_status:"+IntToStr(command_status)+" no_unsuccess:"+IntToStr(no_unsuccess));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Submit_MULTI_RESP_OK(TObject *Sender,
      DWORD sequence_number, AnsiString message_id, BYTE no_unsuccess,
      Tunsuccess_sme unsuccess_sme)
{
ListBox2->Items->Add("Submit_MULTI_RESP_OK: message_id:"+message_id+" no_unsuccess:"+IntToStr(no_unsuccess));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Submit_SM_RESP_Error(TObject *Sender,
      DWORD command_status, DWORD sequence_number, AnsiString message_id)
{
ListBox2->Items->Add("Submit_SM_RESP_Error message_id:"+message_id+"  command_status:"+IntToStr(command_status)+" sequence_number:"+IntToStr(sequence_number));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Submit_SM_RESP_OK(TObject *Sender,
      DWORD sequence_number, AnsiString message_id)
{
ListBox2->Items->Add("Submit_SM_RESP_OK message_id:"+message_id+" sequence_number:"+IntToStr(sequence_number));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Unbind_RESP_Error(TObject *Sender,
      DWORD command_status, DWORD sequence_number)
{
ListBox1->Items->Add("Unbind_RESP_Error command_status:"+IntToStr(command_status));	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Unbind_RESP_OK(TObject *Sender,
      DWORD sequence_number)
{
ListBox1->Items->Add("Unbind_RESP_OK");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrufelSMPPDemo1Unknown_command(TObject *Sender,
      DWORD command_length, DWORD command_id, DWORD command_status,
      DWORD sequence_number, AnsiString Parameters)
{
ListBox2->Items->Add("Unknown_command:"+IntToStr(command_id)+" command_status:"+IntToStr(command_status)+
" sequence_number:"+IntToStr(sequence_number));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
DrufelSMPPDemo1->Disconnect();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button11Click(TObject *Sender)
{
ListBox1->Items->Add("Connected:"+BoolToStr(DrufelSMPPDemo1->Connected,True));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button13Click(TObject *Sender)
{
DrufelSMPPDemo1->Bind(Transceiver,"system_id","password","system_type",0,1,"001");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
DrufelSMPPDemo1->Unbind();	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
Tdest_address dest_address;
TOPSubmit_MULTI OPSubmit_MULTI;
DrufelSMPPDemo1->dest_address_AddSME(dest_address,1,1,"79022880210");
DrufelSMPPDemo1->dest_address_AddSME(dest_address,1,1,"79022880210");
DrufelSMPPDemo1->Submit_MULTI("",5,0,"DrufelSMPP",dest_address,0,0,0,"","",0,0,0,0,"Test Submit_MULTI from DrufelSMPP",OPSubmit_MULTI);
//DrufelSMPPDemo1.Submit_MULTI('',0,1,'001',dest_address,0,0,0,'','',0,0,0,0,'Test Submit_MULTI from DrufelSMPP',OPSubmit_MULTI)
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
TOPSubmit_SM OPSubmit_SM;
ListBox2->Items->Add("Submit_SM sequence_number:"+IntToStr(DrufelSMPPDemo1->Submit_SM("",5,0,"DrufelSMPP",1,1,"79022880210",0,0,0,"","",0,0,0,0,"Test Submit_SM from DrufelSMPP",OPSubmit_SM)));
ListBox2->Items->Add("Submit_SM sequence_number:"+IntToStr(DrufelSMPPDemo1->Submit_SM("",0,1,"001",1,1,"79022880210",0,0,0,"","",0,0,0,0,"Test Submit_SM from DrufelSMPP",OPSubmit_SM)));
//DrufelSMPPDemo1->Submit_SM("",0,1,"001",1,1,"79022880210",0,0,0,"","",0,0,0,0,"Test Submit_SM from DrufelSMPP",OPSubmit_SM)	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
TOPData_SM OPData_SM;

OPData_SM.ms_validity.Field=True;
OPData_SM.ms_validity.Value=1;
OPData_SM.message_payload.Field=True;
OPData_SM.message_payload.Value="Test Data_SM from DrufelSMPP";
DrufelSMPPDemo1->Data_SM("",5,0,"DrufelSMPP",1,1,"79022880210",0,0,0,OPData_SM);
//DrufelSMPPDemo1->Data_SM("",0,1,"001",1,1,"79022880210",0,0,0,OPData_SM);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
DrufelSMPPDemo1->Query_SM("1B643B8",0,1,"001");	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)
{
DrufelSMPPDemo1->Cancel_SM("","1B643B8",0,1,"001",1,1,"79022880210");	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button10Click(TObject *Sender)
{
DrufelSMPPDemo1->Replace_SM("1B64B39",0,1,"001","","",0,0,"The message is changed");	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
DrufelSMPPDemo1->Enquire_LINK();	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button14Click(TObject *Sender)
{
DrufelSMPPDemo1->Generic_NACK(4);
}
//---------------------------------------------------------------------------

